// STAR-CCM+ macro: adaptive_mesh_and_run.java
// Written by STAR-CCM+ 11.06.010
package macro;

import java.util.*;

import star.common.*;
import star.base.neo.*;
import star.meshing.*;
import star.twodmesher.*;

public class adaptive_mesh_and_run extends StarMacro {

  public void execute() {
    execute0();
  }

  private void execute0() {

    Simulation simulation_0 = 
      getActiveSimulation();

    Solution solution_0 = 
      simulation_0.getSolution();

    solution_0.clearSolution();

    AutoMeshOperation2d autoMeshOperation2d_0 = 
      ((AutoMeshOperation2d) simulation_0.get(MeshOperationManager.class).getObject("Automated Mesh (2D)"));

    DualAutoMesher2d dualAutoMesher2d_0 = 
      ((DualAutoMesher2d) autoMeshOperation2d_0.getMeshers().getObject("Polygonal Mesher"));

    dualAutoMesher2d_0.setMeshSizeTable(null);

    StepStoppingCriterion stepStoppingCriterion_0 = 
      ((StepStoppingCriterion) simulation_0.getSolverStoppingCriterionManager().getSolverStoppingCriterion("Maximum Steps"));

    stepStoppingCriterion_0.setMaximumNumberSteps(600);

    MeshPipelineController meshPipelineController_0 = 
      simulation_0.get(MeshPipelineController.class);

    meshPipelineController_0.generateVolumeMesh();

    simulation_0.getSimulationIterator().run();

    XyzInternalTable xyzInternalTable_0 = 
      ((XyzInternalTable) simulation_0.getTableManager().getTable("Refine"));

    dualAutoMesher2d_0.setMeshSizeTable(xyzInternalTable_0);

    xyzInternalTable_0.extract();

    meshPipelineController_0.generateVolumeMesh();

    stepStoppingCriterion_0.setMaximumNumberSteps(900);

    simulation_0.getSimulationIterator().run();

    xyzInternalTable_0.extract();

    meshPipelineController_0.generateVolumeMesh();

    stepStoppingCriterion_0.setMaximumNumberSteps(1200);

    simulation_0.getSimulationIterator().run();

    xyzInternalTable_0.extract();

    meshPipelineController_0.generateVolumeMesh();

    stepStoppingCriterion_0.setMaximumNumberSteps(1500);

    simulation_0.getSimulationIterator().run();
  }
}
